Subject: Re: A Style Guide Question
From: [email-masked] (Mike Meyer)
Date: 16 Nov 92 07:08:02 GMT
Newsgroups: comp.sys.amiga.programmer

In <[email-masked]>, [email-masked] (Dan Drake) wrote:
> This is a style guide question.
> 
> To be consistent in my user interface, I am using buttons called done and 
> cancel, that reside in all of my windows.  I want the user to be able to
> activate these buttons through their keyboard equivalents: eg d for done, 
> and c for cancel.  Now on several of these windows, I want the user to type
> text into a beveled box which I handle manually.  THe problem is that if the
> user wants to type a d or a c, there is some ambiguity concerning what 
> should happen.  Will the buttons be activated, or should the characters
> appear in the "textbox"?  I have 2 solutions, and would be interested in
> any other solutions or recommendations.

I just designed an interface around this same problem.

> 1.) If a text box is active, the user must click on the buttons to activate
> them.  I consider this unacceptable because it ruins the orthogonality of
> the interface.  You can't have some things work in one window, and not in
> others.

I don't particularly like that one, either. It didn't change the
orthoganality of the interface (i.e. - all buttons would be the same),
but it meant you'd have to use the mouse to get to the keyboard
shortcuts.

> 2.) Use (ALT|CTRL|right amiga) key to activate the buttons in all cases.
> Alt doesn't work because European languages use it.  Control is awkward
> for left handed people to use like me. (I like to keep one hand on the
> mouse, and one on the keyboard), Right Amiga is somewhat awkward too.

You forgot that in standard text gadgets, CTRL can do usefull things.

> 3.) Don't use keyboard equivalents.  I really don't like this option.

I agree; it's unacceptable. But you forgot:

4.) Add menu items Done and Cancel that are identical to the buttons,
	and have the shortcuts be Amiga-D and Amiga-C.

That's what I settled on. That made *all* my keyboard shortcuts be
Amiga-<>, and doesn't interfere with the text entry gadget (which was
the bulk of the application). If you're going to have modes where it
wouldn't be active, you might make unadorned d and c work, as well.

	<mike